#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

int main(void) {
	DDRB = _BV(DDB0);
	ADCSRA = _BV(ADEN) | _BV(ADIE);
	// AVCC jako napicie odniesienia
	ADMUX = _BV(REFS0);
	// preskaler 128
	ADCSRA |= _BV(ADPS0)|_BV(ADPS1)|_BV(ADPS2);
	// wyczenie komparatora analogowego
	ACSR = _BV(ACD);
	sei();
	set_sleep_mode(SLEEP_MODE_ADC);
	sleep_enable();
	while (1) {
		sleep_cpu();
	}
}

ISR(ADC_vect) {
	if (ADCW > 511) {
		PORTB |= _BV(PB0);
	} else {
		PORTB &= ~_BV(PB0);
	}
}